clear;
s=%s;
pi=%pi;
i=%i;

//----------------------MATRICES ESPACIO DE ESTADOS---------------------:

A_teo=[0 0 1 0;0 0 0 1;0 691.221 -39.3663 0;0 -1078.67 39.3663 0];
A_aju=[0 0 1 0;0 0 0 1;0 586.854 -43.5916 0;0 -915.802 43.5916 0];
B=[0;0;60.2049;-60.2049];
C=[1 0 0 0;0 1 0 0];
D=[0;0];

//----------------------FUNCIONES DE TRANSFERENCIA----------------------:

g_sin_flex=syslin('c',1.53,0.07*s^2+s);
g_sin_flex_ajustado=syslin('c',1.42,0.08*s^2+s);

ss_teo=syslin('c',A_teo,B,C,D);
tf_teo=ss2tf(syslin('c',A_teo,B,C,D));
g_con_flex=tf_teo(1,1);
f=tf_teo(2,1);

ss_aju=syslin('c',A_aju,B,C,D);
tf_aju=ss2tf(syslin('c',A_aju,B,C,D));
g_con_flex_ajustado=tf_aju(1,1);
f_ajustado=tf_aju(2,1);

T=0.005;

//----------------------------------PD----------------------------------:

R=1e-7; //Muy pequeño.
delta=sqrt(((log(R/100))^2)/((pi^2)+((log(R/100))^2)));

//delta*omega_n<=(4/Tp)

omega_n_min=(4/(delta*1));

//omega_n>=4.0457024 rad/s.

omega_n=8.5;
s1=-delta*omega_n+i*(omega_n*sqrt(1-(delta^2)));

clf(0);
scf(0);
plot(-delta*omega_n_min*ones(0:10),0:10);
sgrid(delta,1);
plot(real(s1),imag(s1),'*');

//s1 polo del sistema == s1 cumple la condición del Argumento

[aux1 db]=phasemag(horner(g_sin_flex_ajustado/(s+200),s1));
aux1_rad=aux1*((2*pi)/360);
aux3=pi-aux1_rad;

//C_PD(s)=k*(s+alfa);

alfa=(imag(s1)-tan(aux3)*real(s1))/tan(aux3); 

gc_PD=syslin('c',s+alfa,s+200);

clf(1);
scf(1);
bode(gc_PD);

clf(2);
scf(2);
evans(gc_PD*g_sin_flex_ajustado);
plot(real(s1),imag(s1),'*');

k=1/abs(horner(gc_PD*g_sin_flex_ajustado,s1));

clf(3);
scf(3);
bode(k*gc_PD);

glc=(k*gc_PD*g_sin_flex_ajustado)/(1+k*gc_PD*g_sin_flex_ajustado);

clf(4);
scf(4);
plzr(glc);
plot(real(s1),imag(s1),'*');

t=0:T:2;
y=csim('step',t,glc);

clf(5);
scf(5);
plot(t,y);

gu=(k*gc_PD)/(1+k*gc_PD*g_sin_flex_ajustado);

y_u=csim('step',t,gu);

clf(6);
scf(6);
plot(t,y_u);

//-----------------------------FILTRO NOTCH-----------------------------:

fn=3.4;
omega_n_notch=2*pi*fn;
a=1;
delta_notch=0.5;

g_notch=syslin('c',(s^2+2*delta_notch*omega_n_notch*s+(omega_n_notch^2))*(a*omega_n_notch)*(omega_n_notch/a),(omega_n_notch^2)*(s+a*omega_n_notch)*(s+(omega_n_notch/a)));

//------------------------------PD + NOTCH------------------------------:

gc=k*gc_PD*g_notch;

clf(7);
scf(7);
bode(gc);

glc_notch=(gc*g_con_flex_ajustado)/(1+gc*g_con_flex_ajustado);

clf(8);
scf(8);
plzr(glc_notch);
plot(real(s1),imag(s1),'*');
replot([-80 -40 10 40]);

y_notch=csim('step',t,glc_notch);

clf(9);
scf(9);
plot(t,y);
plot(t,y_notch,"r");

gu_notch=(gc)/(1+gc*g_con_flex_ajustado);

y_notch_u=csim('step',t,gu_notch);

clf(10);
scf(10);
plot(t,y_u);
plot(t,y_notch_u,"r");
