clear;
s=%s;
pi=%pi;
i=%i;

//----------------------MATRICES ESPACIO DE ESTADOS---------------------:

A_teo=[0 0 1 0;0 0 0 1;0 691.221 -39.3663 0;0 -1078.67 39.3663 0];
A_aju=[0 0 1 0;0 0 0 1;0 586.854 -43.5916 0;0 -915.802 43.5916 0];
B=[0;0;60.2049;-60.2049];
C=[1 0 0 0;0 1 0 0];
D=[0;0];

//----------------------FUNCIONES DE TRANSFERENCIA----------------------:

g_sin_flex=syslin('c',1.53,0.07*s^2+s);
g_sin_flex_ajustado=syslin('c',1.42,0.08*s^2+s);

ss_teo=syslin('c',A_teo,B,C,D);
tf_teo=ss2tf(syslin('c',A_teo,B,C,D));
g_con_flex=tf_teo(1,1);
f=tf_teo(2,1);

ss_aju=syslin('c',A_aju,B,C,D);
tf_aju=ss2tf(syslin('c',A_aju,B,C,D));
g_con_flex_ajustado=tf_aju(1,1);
f_ajustado=tf_aju(2,1);

T=0.005;

//----------------------------------PI----------------------------------:

k_PI=2.8;

//Cero cercano:
alfa=0.05;

gc_PI=syslin('c',s+alfa,s);

clf(0);
scf(0);
bode(k_PI*gc_PI);

glc_PI=(k_PI*gc_PI*g_sin_flex_ajustado)/(1+k_PI*gc_PI*g_sin_flex_ajustado);

clf(1);
scf(1);
plzr(glc_PI);

t=0:T:2;
y=csim('step',t,glc_PI);

clf(2);
scf(2);
plot(t,y);

gu=(k_PI*gc_PI)/(1+k_PI*gc_PI*g_sin_flex_ajustado);

y_u=csim('step',t,gu);

clf(3);
scf(3);
plot(t,y_u);

//-----------------------------FILTRO NOTCH-----------------------------:

fn=3.4;
omega_n_notch=2*pi*fn;
a=1;
delta_notch=0.5;

g_notch=syslin('c',(s^2+2*delta_notch*omega_n_notch*s+(omega_n_notch^2))*(a*omega_n_notch)*(omega_n_notch/a),(omega_n_notch^2)*(s+a*omega_n_notch)*(s+(omega_n_notch/a)));

//------------------------------PI + NOTCH------------------------------:

gc=k_PI*gc_PI*g_notch;

clf(4);
scf(4);
bode(gc);

glc_notch=(gc*g_con_flex_ajustado)/(1+gc*g_con_flex_ajustado);

clf(5);
scf(5);
plzr(glc_notch);

y_notch=csim('step',t,glc_notch);

clf(6);
scf(6);
plot(t,y);
plot(t,y_notch,"r");

gu_notch=(gc)/(1+gc*g_con_flex_ajustado);

y_notch_u=csim('step',t,gu_notch);

clf(7);
scf(7);
plot(t,y_u);
plot(t,y_notch_u,"r");
