clear;
s=%s;
pi=%pi;

//----------------------MATRICES ESPACIO DE ESTADOS---------------------:

A_teo=[0 0 1 0;0 0 0 1;0 691.221 -39.3663 0;0 -1078.67 39.3663 0];
A_aju=[0 0 1 0;0 0 0 1;0 586.854 -43.5916 0;0 -915.802 43.5916 0];
B=[0;0;60.2049;-60.2049];
C=[1 0 0 0;0 1 0 0];
D=[0;0];

//----------------------FUNCIONES DE TRANSFERENCIA----------------------:

g_sin_flex=syslin('c',1.53,0.07*s^2+s);
g_sin_flex_ajustado=syslin('c',1.42,0.08*s^2+s);

ss_teo=syslin('c',A_teo,B,C,D);
tf_teo=ss2tf(syslin('c',A_teo,B,C,D));
g_con_flex=tf_teo(1,1);
f=tf_teo(2,1);

ss_aju=syslin('c',A_aju,B,C,D);
tf_aju=ss2tf(syslin('c',A_aju,B,C,D));
g_con_flex_ajustado=tf_aju(1,1);
f_ajustado=tf_aju(2,1);

//-----------------------ESPECIFICACIÓN DE REBOSE-----------------------:

R=3;
delta=sqrt(((log(R/100))^2)/((pi^2)+((log(R/100))^2)));
MF_rad=atan((2*delta)/(sqrt(sqrt(1+4*(delta^4))-2*(delta^2))));
MF=(360/(2*pi))*MF_rad;

T=0.005;

//-----------------------------RED DE ATRASO----------------------------:

k=4.5;
gla=k*g_sin_flex_ajustado;

clf(0);
scf(0);
show_margins(gla);

[mf_inic,fgc_inic]=p_margin(gla);

//180-MF=112.6º -> En -111.5º (0.7847 Hz) -> 1.638 dB

a_atr=10^(-1.638/20);
T_atr=10/(2*pi*0.7847*a_atr);

red_atr=syslin('c',1+a_atr*T_atr*s,1+T_atr*s);

clf(1);
scf(1);
bode(k*red_atr);

gla_atr=k*red_atr*g_sin_flex_ajustado;

clf(2);
scf(2);
show_margins(gla_atr);

[mf_atr,fgc_atr]=p_margin(gla_atr);

glc_atr=(k*red_atr*g_sin_flex_ajustado)/(1+k*red_atr*g_sin_flex_ajustado);

t_atr=0:T:2;
y_atr=csim('step',t_atr,glc_atr);

clf(3);
scf(3);
plot(t_atr,y_atr);

gu_atr=(k*red_atr)/(1+k*red_atr*g_sin_flex_ajustado);

t_atr1=0:T:2;
y_atr1=csim('step',t_atr1,gu_atr);

clf(4);
scf(4);
plot(t_atr1,y_atr1);

//-----------------------------FILTRO NOTCH-----------------------------:

fn=3.4;
omega_n_notch=2*pi*fn;
a=1;
delta_notch=0.5;

g_notch=syslin('c',(s^2+2*delta_notch*omega_n_notch*s+(omega_n_notch^2))*(a*omega_n_notch)*(omega_n_notch/a),(omega_n_notch^2)*(s+a*omega_n_notch)*(s+(omega_n_notch/a)));

//-------------------------RED DE ATRASO + NOTCH------------------------:

gc=k*red_atr*g_notch;

clf(5);
scf(5);
bode(gc);

gla_atr_notch=gc*g_con_flex_ajustado;

clf(6);
scf(6);
show_margins(gla_atr_notch);

[mf_atr_notch,fgc_atr_notch]=p_margin(gla_atr_notch);

glc_atr_notch=(gc*g_con_flex_ajustado)/(1+gc*g_con_flex_ajustado);

t_atr_notch=0:T:2;
y_atr_notch=csim('step',t_atr_notch,glc_atr_notch);

clf(7);
scf(7);
plot(t_atr,y_atr);
plot(t_atr_notch,y_atr_notch,"r");

gu_atr_notch=(gc)/(1+gc*g_con_flex_ajustado);

t_atr_notch1=0:T:2;
y_atr_notch1=csim('step',t_atr_notch1,gu_atr_notch);

clf(8);
scf(8);
plot(t_atr1,y_atr1);
plot(t_atr_notch1,y_atr_notch1,"r");
