clear;
s=%s;
pi=%pi;
i=%i;

//----------------------MATRICES ESPACIO DE ESTADOS---------------------:

A=[0 0 1 0;0 0 0 1;0 586.854 -43.5916 0;0 -915.802 43.5916 0];
B=[0;0;60.2049;-60.2049];
C=[1 0 0 0;0 1 0 0];
D=[0;0];

//----------------------FUNCIONES DE TRANSFERENCIA----------------------:

sistema=syslin('c',A,B,C,D);
fts=ss2tf(sistema);
g=fts(1,1);
f=fts(2,1);

//-----------------REALIMENTACIÓN DE VARIABLES DE ESTADO----------------:

R=2;
delta=sqrt(((log(R/100))^2)/((pi^2)+((log(R/100))^2)));

//delta*omega_n<=(4/Tp)

omega_n_min=(4/(delta*1));

//omega_n>=5.1301568 rad/s.

omega_n=7;

s1=-delta*omega_n+i*(omega_n*sqrt(1-(delta^2)));
s2=conj(s1);
s3=-100;
s4=-100;

clf(0);
scf(0);
plot(-delta*omega_n_min*ones(0:6),0:6);
sgrid(delta,1);
plot(real(s1),imag(s1),'*');

//CONTROLABILIDAD:

Pc=[B A*B (A^2)*B (A^3)*B];
det_Pc=det(Pc); //det_Pc!=0 -> Controlable

//MÉTODO DE ACKERMANN:

K=ppol(A,B,[s1,s2,s3,s4]);
