clear;
s=%s;

//----------------------MATRICES ESPACIO DE ESTADOS---------------------:

A_teo=[0 0 1 0;0 0 0 1;0 691.221 -39.3663 0;0 -1078.67 39.3663 0];
A_aju=[0 0 1 0;0 0 0 1;0 586.854 -43.5916 0;0 -915.802 43.5916 0];
B=[0;0;60.2049;-60.2049];
C=[1 0 0 0;0 1 0 0];
D=[0;0];

//----------------------FUNCIONES DE TRANSFERENCIA----------------------:

g_sin_flex=syslin('c',1.53,0.07*s^2+s);
g_sin_flex_ajustado=syslin('c',1.42,0.08*s^2+s);

ss_teo=syslin('c',A_teo,B,C,D);
tf_teo=ss2tf(syslin('c',A_teo,B,C,D));
g_con_flex=tf_teo(1,1);
f=tf_teo(2,1);

ss_aju=syslin('c',A_aju,B,C,D);
tf_aju=ss2tf(syslin('c',A_aju,B,C,D));
g_con_flex_ajustado=tf_aju(1,1);
f_ajustado=tf_aju(2,1);

//--------------------SERVOMOTOR (SIN ÁNGULO DE FLEX)-------------------:

clf(0);
scf(0);
bode(g_sin_flex);

clf(1);
scf(1);
plzr(g_sin_flex);

clf(2);
scf(2);
bode(g_sin_flex_ajustado);

clf(3);
scf(3);
plzr(g_sin_flex_ajustado);

//COMPARACIÓN BODES:

clf(4);
scf(4);
bode([g_sin_flex;g_sin_flex_ajustado]);

//--------------------SERVOMOTOR (CON ÁNGULO DE FLEX)-------------------:

clf(5);
scf(5);
bode(g_con_flex);

clf(6);
scf(6);
plzr(g_con_flex);

clf(7);
scf(7);
bode(g_con_flex_ajustado);

clf(8);
scf(8);
plzr(g_con_flex_ajustado);

//COMPARACIÓN BODES:

clf(9);
scf(9);
bode([g_con_flex;g_con_flex_ajustado]);


//------------------------SERVOMOTOR (COMPARACIÓN)----------------------:

clf(10);
scf(10);
bode([g_sin_flex;g_sin_flex_ajustado;g_con_flex;g_con_flex_ajustado]);


//---------------------------------FLEX---------------------------------:

clf(11);
scf(11);
bode(f);

clf(12);
scf(12);
bode(f_ajustado);

//COMPARACIÓN BODES:

clf(13);
scf(13);
bode([f;f_ajustado]);
