clear;
s=%s;
pi=%pi;

//------------------------------CONSTANTES------------------------------:
Jl=0.0038; //kg.m^2
Bl=0; //N.m.s/rad
Ks_teo=1.4723; //N.m/rad
Ks_aju=1.25; //N.m/rad
g=9.81; //m/s^2

Rm=2.6; //Ohm
km=0.00767; //V.s/rad
kt=0.00767; //N.m/A
Jeq=0.00213; //kg.m^2
Beq_teo=0.015; //N.m.s/rad
Beq_aju=0.024; //N.m.s/rad
eff_g=0.9;
eff_m=0.69;
Kg=70;

M=(eff_g*Kg*eff_m*kt)/Rm;
N=(eff_g*(Kg^2)*eff_m*kt*km)/Rm;

//-------------------------------MATRICES-------------------------------:

A_teo=[0 0 1 0;0 0 0 1;0 Ks_teo/Jeq -(Beq_teo+N)/Jeq 0;0 -Ks_teo*(Jeq+Jl)/(Jeq*Jl) (Beq_teo+N)/Jeq 0];
A_aju=[0 0 1 0;0 0 0 1;0 Ks_aju/Jeq -(Beq_aju+N)/Jeq 0;0 -Ks_aju*(Jeq+Jl)/(Jeq*Jl) (Beq_aju+N)/Jeq 0];
B=[0;0;M/Jeq;-M/Jeq];
C=[1 0 0 0;0 1 0 0];
D=[0;0];

//------------------------------RESULTADOS------------------------------:

A_teo=[0 0 1 0;0 0 0 1;0 691.221 -39.3663 0;0 -1078.67 39.3663 0];
A_aju=[0 0 1 0;0 0 0 1;0 586.854 -43.5916 0;0 -915.802 43.5916 0];
B=[0;0;60.2049;-60.2049];
C=[1 0 0 0;0 1 0 0];
D=[0;0];

//----------------------FUNCIONES DE TRANSFERENCIA----------------------:

ss_teo=syslin('c',A_teo,B,C,D);
tf_teo=ss2tf(ss_teo);
g_teo=tf_teo(1,1);
f_teo=tf_teo(2,1);

ss_aju=syslin('c',A_aju,B,C,D);
tf_aju=ss2tf(ss_aju);
g_aju=tf_aju(1,1);
f_aju=tf_aju(2,1);
